org.eclipse.viatra.cep.vepl.serializer

## Class VeplSemanticSequencer

- java.lang.Object
- - org.eclipse.xtext.serializer.sequencer.AbstractSemanticSequencer
  - - org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer
    - - org.eclipse.xtext.xbase.serializer.AbstractXtypeSemanticSequencer
      - - org.eclipse.xtext.xbase.serializer.XtypeSemanticSequencer
        - - org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer
          - - org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer
            - - org.eclipse.viatra.cep.vepl.serializer.VeplSemanticSequencer

- All Implemented Interfaces:
    org.eclipse.xtext.serializer.sequencer.ISemanticSequencer

      public class VeplSemanticSequencer
      extends org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer

      `OPERATOR_NOT_SUPPORTED`

    - ### Fields inherited from class org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer

      `genericSequencer, genericSequencerProvider`

    - ### Fields inherited from class org.eclipse.xtext.serializer.sequencer.AbstractSemanticSequencer

      `diagnosticProvider, errorAcceptor, feederProvider, masterSequencer, nodeProvider, sequenceAcceptor, transientValues`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `VeplSemanticSequencer()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `sequence_AndOperator(org.eclipse.xtext.serializer.ISerializationContext context, AndOperator semanticObject)` Contexts: ComplexEventOperator returns AndOperator BinaryOperator returns AndOperator AndOperator returns AndOperator Constraint: {AndOperator}
    `protected void` | `sequence_AtLeastOne(org.eclipse.xtext.serializer.ISerializationContext context, AtLeastOne semanticObject)` Contexts: AbstractMultiplicity returns AtLeastOne AtLeastOne returns AtLeastOne Constraint: {AtLeastOne}
    `protected void` | `sequence_Atom_NormalPrimary(org.eclipse.xtext.serializer.ISerializationContext context, Atom semanticObject)` Contexts: ComplexEventExpression.ComplexEventExpression_1_0 returns Atom Primary returns Atom NormalPrimary returns Atom Constraint: (patternCall=ParameterizedPatternCall multiplicity=AbstractMultiplicity? timewindow=Timewindow?)
    `protected void` | `sequence_Atom(org.eclipse.xtext.serializer.ISerializationContext context, Atom semanticObject)` Contexts: Atom returns Atom Constraint: patternCall=ParameterizedPatternCall
    `protected void` | `sequence_AtomicEventPattern(org.eclipse.xtext.serializer.ISerializationContext context, AtomicEventPattern semanticObject)` Contexts: ModelElement returns AtomicEventPattern EventPattern returns AtomicEventPattern AbstractAtomicEventPattern returns AtomicEventPattern AtomicEventPattern returns AtomicEventPattern Constraint: (name=ID parameters=TypedParameterList? traits=TraitList? checkExpression=XBlockExpression?)
    `protected void` | `sequence_ChainedExpression(org.eclipse.xtext.serializer.ISerializationContext context, ChainedExpression semanticObject)` Contexts: ChainedExpression returns ChainedExpression Constraint: (operator=BinaryOperator expression=Primary)
    `protected void` | `sequence_ComplexEventExpression_NegatedPrimary_NormalPrimary_ComplexEventExpression_1_0(org.eclipse.xtext.serializer.ISerializationContext context, ComplexEventExpression semanticObject)` Contexts: ComplexEventExpression.ComplexEventExpression_1_0 returns ComplexEventExpression Primary returns ComplexEventExpression Constraint: ( (left=ComplexEventExpression_ComplexEventExpression_1_0 right+=ChainedExpression* multiplicity=AbstractMultiplicity? timewindow=Timewindow?) | (negOperator=NegOperator left=NormalPrimary) )
    `protected void` | `sequence_ComplexEventExpression_NormalPrimary(org.eclipse.xtext.serializer.ISerializationContext context, ComplexEventExpression semanticObject)` Contexts: NormalPrimary returns ComplexEventExpression Constraint: (left=ComplexEventExpression_ComplexEventExpression_1_0 right+=ChainedExpression* multiplicity=AbstractMultiplicity? timewindow=Timewindow?)
    `protected void` | `sequence_ComplexEventExpression(org.eclipse.xtext.serializer.ISerializationContext context, ComplexEventExpression semanticObject)` Contexts: ComplexEventExpression returns ComplexEventExpression Constraint: (left=ComplexEventExpression_ComplexEventExpression_1_0 right+=ChainedExpression*)
    `protected void` | `sequence_ComplexEventPattern(org.eclipse.xtext.serializer.ISerializationContext context, ComplexEventPattern semanticObject)` Contexts: ModelElement returns ComplexEventPattern EventPattern returns ComplexEventPattern ComplexEventPattern returns ComplexEventPattern Constraint: (name=ID parameters=TypedParameterList? complexEventExpression=ComplexEventExpression context=Context?)
    `protected void` | `sequence_EventModel(org.eclipse.xtext.serializer.ISerializationContext context, EventModel semanticObject)` Contexts: EventModel returns EventModel Constraint: (name=QualifiedName imports+=Import* context=Context? modelElements+=ModelElement*)
    `protected void` | `sequence_FollowsOperator(org.eclipse.xtext.serializer.ISerializationContext context, FollowsOperator semanticObject)` Contexts: ComplexEventOperator returns FollowsOperator BinaryOperator returns FollowsOperator FollowsOperator returns FollowsOperator Constraint: {FollowsOperator}
    `protected void` | `sequence_GenericImport(org.eclipse.xtext.serializer.ISerializationContext context, GenericImport semanticObject)` Contexts: Import returns GenericImport GenericImport returns GenericImport Constraint: importedNamespace=QualifiedNameWithWildcard
    `protected void` | `sequence_Infinite(org.eclipse.xtext.serializer.ISerializationContext context, Infinite semanticObject)` Contexts: AbstractMultiplicity returns Infinite Infinite returns Infinite Constraint: {Infinite}
    `protected void` | `sequence_Multiplicity(org.eclipse.xtext.serializer.ISerializationContext context, Multiplicity semanticObject)` Contexts: AbstractMultiplicity returns Multiplicity Multiplicity returns Multiplicity Constraint: value=INT
    `protected void` | `sequence_NegatedPrimary(org.eclipse.xtext.serializer.ISerializationContext context, ComplexEventExpression semanticObject)` Contexts: NegatedPrimary returns ComplexEventExpression Constraint: (negOperator=NegOperator left=NormalPrimary)
    `protected void` | `sequence_NegOperator(org.eclipse.xtext.serializer.ISerializationContext context, NegOperator semanticObject)` Contexts: ComplexEventOperator returns NegOperator UnaryOperator returns NegOperator NegOperator returns NegOperator Constraint: {NegOperator}
    `protected void` | `sequence_OrOperator(org.eclipse.xtext.serializer.ISerializationContext context, OrOperator semanticObject)` Contexts: ComplexEventOperator returns OrOperator BinaryOperator returns OrOperator OrOperator returns OrOperator Constraint: {OrOperator}
    `protected void` | `sequence_ParameterizedPatternCall(org.eclipse.xtext.serializer.ISerializationContext context, ParameterizedPatternCall semanticObject)` Contexts: ParameterizedPatternCall returns ParameterizedPatternCall Constraint: (eventPattern=[EventPattern|ID] parameterList=PatternCallParameterList?)
    `protected void` | `sequence_ParametrizedQueryReference(org.eclipse.xtext.serializer.ISerializationContext context, ParametrizedQueryReference semanticObject)` Contexts: ParametrizedQueryReference returns ParametrizedQueryReference Constraint: (query=[Pattern|ID] parameterList=PatternCallParameterList?)
    `protected void` | `sequence_PatternCallParameter(org.eclipse.xtext.serializer.ISerializationContext context, PatternCallParameter semanticObject)` Contexts: PatternCallParameter returns PatternCallParameter Constraint: name=ID
    `protected void` | `sequence_PatternCallParameterList(org.eclipse.xtext.serializer.ISerializationContext context, PatternCallParameterList semanticObject)` Contexts: PatternCallParameterList returns PatternCallParameterList Constraint: (parameters+=PatternCallParameter parameters+=PatternCallParameter*)
    `protected void` | `sequence_QueryImport(org.eclipse.xtext.serializer.ISerializationContext context, QueryImport semanticObject)` Contexts: Import returns QueryImport QueryImport returns QueryImport Constraint: importedNamespace=QualifiedNameWithWildcard
    `protected void` | `sequence_QueryResultChangeEventPattern(org.eclipse.xtext.serializer.ISerializationContext context, QueryResultChangeEventPattern semanticObject)` Contexts: ModelElement returns QueryResultChangeEventPattern EventPattern returns QueryResultChangeEventPattern AbstractAtomicEventPattern returns QueryResultChangeEventPattern QueryResultChangeEventPattern returns QueryResultChangeEventPattern Constraint: (name=ID parameters=TypedParameterList? queryReference=ParametrizedQueryReference resultChangeType=QueryResultChangeType?)
    `protected void` | `sequence_Rule(org.eclipse.xtext.serializer.ISerializationContext context, Rule semanticObject)` Contexts: ModelElement returns Rule Rule returns Rule Constraint: (name=ID eventPatterns+=ParameterizedPatternCall eventPatterns+=ParameterizedPatternCall* action=XBlockExpression)
    `protected void` | `sequence_Timewindow(org.eclipse.xtext.serializer.ISerializationContext context, Timewindow semanticObject)` Contexts: Timewindow returns Timewindow Constraint: length=INT
    `protected void` | `sequence_Trait(org.eclipse.xtext.serializer.ISerializationContext context, Trait semanticObject)` Contexts: ModelElement returns Trait Trait returns Trait Constraint: (name=ID parameters=TraitTypedParameterList)
    `protected void` | `sequence_TraitList(org.eclipse.xtext.serializer.ISerializationContext context, TraitList semanticObject)` Contexts: TraitList returns TraitList Constraint: (traits+=[Trait|ID] traits+=[Trait|ID]*)
    `protected void` | `sequence_TraitTypedParameterList(org.eclipse.xtext.serializer.ISerializationContext context, TraitTypedParameterList semanticObject)` Contexts: TraitTypedParameterList returns TraitTypedParameterList Constraint: (parameters+=TypedParameterWithDefaultValue parameters+=TypedParameterWithDefaultValue*)
    `protected void` | `sequence_TypedParameter(org.eclipse.xtext.serializer.ISerializationContext context, TypedParameter semanticObject)` Contexts: TypedParameter returns TypedParameter Constraint: (name=ID type=JvmTypeReference)
    `protected void` | `sequence_TypedParameterList(org.eclipse.xtext.serializer.ISerializationContext context, TypedParameterList semanticObject)` Contexts: TypedParameterList returns TypedParameterList Constraint: (parameters+=TypedParameter parameters+=TypedParameter*)
    `protected void` | `sequence_TypedParameterWithDefaultValue(org.eclipse.xtext.serializer.ISerializationContext context, TypedParameterWithDefaultValue semanticObject)` Contexts: TypedParameterWithDefaultValue returns TypedParameterWithDefaultValue Constraint: (typedParameter=TypedParameter value=XAssignment?)
    `protected void` | `sequence_UntilOperator(org.eclipse.xtext.serializer.ISerializationContext context, UntilOperator semanticObject)` Contexts: UntilOperator returns UntilOperator Constraint: {UntilOperator}
    `void` | `sequence(org.eclipse.xtext.serializer.ISerializationContext context, org.eclipse.emf.ecore.EObject semanticObject)`

    - ### Methods inherited from class org.eclipse.xtext.xbase.serializer.XbaseSemanticSequencer

      `getValidOperator, isBuilderSyntax, isBuilderSyntax, isXShortClosure, isXShortClosure, isXShortClosureAndBuilderSyntax, sequence_XAdditiveExpression_XAndExpression_XAssignment_XEqualityExpression_XMultiplicativeExpression_XOrExpression_XOtherOperatorExpression_XRelationalExpression, sequence_XAdditiveExpression, sequence_XAssignment, sequence_XConstructorCall, sequence_XExpression, sequence_XFeatureCall, sequence_XMemberFeatureCall`

    - ### Methods inherited from class org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer

      `sequence_FullJvmFormalParameter, sequence_FullJvmFormalParameter, sequence_JvmFormalParameter, sequence_JvmFormalParameter, sequence_XAdditiveExpression_XAndExpression_XAssignment_XEqualityExpression_XMultiplicativeExpression_XOrExpression_XOtherOperatorExpression_XRelationalExpression, sequence_XAssignment_XMemberFeatureCall, sequence_XAssignment_XMemberFeatureCall, sequence_XBasicForLoopExpression, sequence_XBasicForLoopExpression, sequence_XBlockExpression, sequence_XBlockExpression, sequence_XBooleanLiteral, sequence_XBooleanLiteral, sequence_XCasePart, sequence_XCasePart, sequence_XCastedExpression, sequence_XCastedExpression, sequence_XCatchClause, sequence_XCatchClause, sequence_XClosure, sequence_XClosure, sequence_XConstructorCall, sequence_XDoWhileExpression, sequence_XDoWhileExpression, sequence_XExpressionInClosure, sequence_XExpressionInClosure, sequence_XFeatureCall, sequence_XForLoopExpression, sequence_XForLoopExpression, sequence_XIfExpression, sequence_XIfExpression, sequence_XListLiteral, sequence_XListLiteral, sequence_XMemberFeatureCall, sequence_XNullLiteral, sequence_XNullLiteral, sequence_XNumberLiteral, sequence_XNumberLiteral, sequence_XPostfixOperation, sequence_XPostfixOperation, sequence_XRelationalExpression, sequence_XRelationalExpression, sequence_XReturnExpression, sequence_XReturnExpression, sequence_XSetLiteral, sequence_XSetLiteral, sequence_XShortClosure, sequence_XShortClosure, sequence_XStringLiteral, sequence_XStringLiteral, sequence_XSwitchExpression, sequence_XSwitchExpression, sequence_XSynchronizedExpression, sequence_XSynchronizedExpression, sequence_XThrowExpression, sequence_XThrowExpression, sequence_XTryCatchFinallyExpression, sequence_XTryCatchFinallyExpression, sequence_XTypeLiteral, sequence_XTypeLiteral, sequence_XUnaryOperation, sequence_XUnaryOperation, sequence_XVariableDeclaration, sequence_XVariableDeclaration, sequence_XWhileExpression, sequence_XWhileExpression`

    - ### Methods inherited from class org.eclipse.xtext.xbase.serializer.AbstractXtypeSemanticSequencer

      `sequence_JvmLowerBound, sequence_JvmLowerBound, sequence_JvmLowerBoundAnded, sequence_JvmLowerBoundAnded, sequence_JvmParameterizedTypeReference_JvmInnerTypeReference_1_4_0_0_0, sequence_JvmParameterizedTypeReference_JvmInnerTypeReference_1_4_0_0_0, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference, sequence_JvmParameterizedTypeReference, sequence_JvmTypeParameter, sequence_JvmTypeParameter, sequence_JvmTypeReference, sequence_JvmTypeReference, sequence_JvmUpperBound, sequence_JvmUpperBound, sequence_JvmUpperBoundAnded, sequence_JvmUpperBoundAnded, sequence_JvmWildcardTypeReference, sequence_JvmWildcardTypeReference, sequence_XFunctionTypeRef, sequence_XFunctionTypeRef, sequence_XImportDeclaration, sequence_XImportDeclaration, sequence_XImportSection, sequence_XImportSection`

    - ### Methods inherited from class org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer

      `init`

    - ### Methods inherited from class org.eclipse.xtext.serializer.sequencer.AbstractSemanticSequencer

      `createContext, createNodeProvider, createSequence, createSequence, createSequencerFeeder, createSequencerFeeder, createSequencerFeeder, createSequencerFeeder, init, setMasterSequencer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### VeplSemanticSequencer

          public VeplSemanticSequencer()

  - ### Method Detail

    - #### sequence

          public void sequence(org.eclipse.xtext.serializer.ISerializationContext context,
                               org.eclipse.emf.ecore.EObject semanticObject)

      Overrides:
        `sequence` in class `org.eclipse.xtext.xbase.serializer.AbstractXbaseSemanticSequencer`

    - #### sequence_AndOperator

          protected void sequence_AndOperator(org.eclipse.xtext.serializer.ISerializationContext context,
                                              AndOperator semanticObject)

      Contexts: ComplexEventOperator returns AndOperator BinaryOperator returns AndOperator AndOperator returns AndOperator Constraint: {AndOperator}

    - #### sequence_AtLeastOne

          protected void sequence_AtLeastOne(org.eclipse.xtext.serializer.ISerializationContext context,
                                             AtLeastOne semanticObject)

      Contexts: AbstractMultiplicity returns AtLeastOne AtLeastOne returns AtLeastOne Constraint: {AtLeastOne}

    - #### sequence_Atom

          protected void sequence_Atom(org.eclipse.xtext.serializer.ISerializationContext context,
                                       Atom semanticObject)

      Contexts: Atom returns Atom Constraint: patternCall=ParameterizedPatternCall

    - #### sequence_Atom_NormalPrimary

          protected void sequence_Atom_NormalPrimary(org.eclipse.xtext.serializer.ISerializationContext context,
                                                     Atom semanticObject)

      Contexts: ComplexEventExpression.ComplexEventExpression_1_0 returns Atom Primary returns Atom NormalPrimary returns Atom Constraint: (patternCall=ParameterizedPatternCall multiplicity=AbstractMultiplicity? timewindow=Timewindow?)

    - #### sequence_AtomicEventPattern

          protected void sequence_AtomicEventPattern(org.eclipse.xtext.serializer.ISerializationContext context,
                                                     AtomicEventPattern semanticObject)

      Contexts: ModelElement returns AtomicEventPattern EventPattern returns AtomicEventPattern AbstractAtomicEventPattern returns AtomicEventPattern AtomicEventPattern returns AtomicEventPattern Constraint: (name=ID parameters=TypedParameterList? traits=TraitList? checkExpression=XBlockExpression?)

    - #### sequence_ChainedExpression

          protected void sequence_ChainedExpression(org.eclipse.xtext.serializer.ISerializationContext context,
                                                    ChainedExpression semanticObject)

      Contexts: ChainedExpression returns ChainedExpression Constraint: (operator=BinaryOperator expression=Primary)

    - #### sequence_ComplexEventExpression

          protected void sequence_ComplexEventExpression(org.eclipse.xtext.serializer.ISerializationContext context,
                                                         ComplexEventExpression semanticObject)

      Contexts: ComplexEventExpression returns ComplexEventExpression Constraint: (left=ComplexEventExpression_ComplexEventExpression_1_0 right+=ChainedExpression*)

    - #### sequence_ComplexEventExpression_NegatedPrimary_NormalPrimary_ComplexEventExpression_1_0

          protected void sequence_ComplexEventExpression_NegatedPrimary_NormalPrimary_ComplexEventExpression_1_0(org.eclipse.xtext.serializer.ISerializationContext context,
                                                                                                                 ComplexEventExpression semanticObject)

      Contexts: ComplexEventExpression.ComplexEventExpression_1_0 returns ComplexEventExpression Primary returns ComplexEventExpression Constraint: ( (left=ComplexEventExpression_ComplexEventExpression_1_0 right+=ChainedExpression* multiplicity=AbstractMultiplicity? timewindow=Timewindow?) | (negOperator=NegOperator left=NormalPrimary) )

    - #### sequence_ComplexEventExpression_NormalPrimary

          protected void sequence_ComplexEventExpression_NormalPrimary(org.eclipse.xtext.serializer.ISerializationContext context,
                                                                       ComplexEventExpression semanticObject)

      Contexts: NormalPrimary returns ComplexEventExpression Constraint: (left=ComplexEventExpression_ComplexEventExpression_1_0 right+=ChainedExpression* multiplicity=AbstractMultiplicity? timewindow=Timewindow?)

    - #### sequence_ComplexEventPattern

          protected void sequence_ComplexEventPattern(org.eclipse.xtext.serializer.ISerializationContext context,
                                                      ComplexEventPattern semanticObject)

      Contexts: ModelElement returns ComplexEventPattern EventPattern returns ComplexEventPattern ComplexEventPattern returns ComplexEventPattern Constraint: (name=ID parameters=TypedParameterList? complexEventExpression=ComplexEventExpression context=Context?)

    - #### sequence_EventModel

          protected void sequence_EventModel(org.eclipse.xtext.serializer.ISerializationContext context,
                                             EventModel semanticObject)

      Contexts: EventModel returns EventModel Constraint: (name=QualifiedName imports+=Import* context=Context? modelElements+=ModelElement*)

    - #### sequence_FollowsOperator

          protected void sequence_FollowsOperator(org.eclipse.xtext.serializer.ISerializationContext context,
                                                  FollowsOperator semanticObject)

      Contexts: ComplexEventOperator returns FollowsOperator BinaryOperator returns FollowsOperator FollowsOperator returns FollowsOperator Constraint: {FollowsOperator}

    - #### sequence_GenericImport

          protected void sequence_GenericImport(org.eclipse.xtext.serializer.ISerializationContext context,
                                                GenericImport semanticObject)

      Contexts: Import returns GenericImport GenericImport returns GenericImport Constraint: importedNamespace=QualifiedNameWithWildcard

    - #### sequence_Infinite

          protected void sequence_Infinite(org.eclipse.xtext.serializer.ISerializationContext context,
                                           Infinite semanticObject)

      Contexts: AbstractMultiplicity returns Infinite Infinite returns Infinite Constraint: {Infinite}

    - #### sequence_Multiplicity

          protected void sequence_Multiplicity(org.eclipse.xtext.serializer.ISerializationContext context,
                                               Multiplicity semanticObject)

      Contexts: AbstractMultiplicity returns Multiplicity Multiplicity returns Multiplicity Constraint: value=INT

    - #### sequence_NegOperator

          protected void sequence_NegOperator(org.eclipse.xtext.serializer.ISerializationContext context,
                                              NegOperator semanticObject)

      Contexts: ComplexEventOperator returns NegOperator UnaryOperator returns NegOperator NegOperator returns NegOperator Constraint: {NegOperator}

    - #### sequence_NegatedPrimary

          protected void sequence_NegatedPrimary(org.eclipse.xtext.serializer.ISerializationContext context,
                                                 ComplexEventExpression semanticObject)

      Contexts: NegatedPrimary returns ComplexEventExpression Constraint: (negOperator=NegOperator left=NormalPrimary)

    - #### sequence_OrOperator

          protected void sequence_OrOperator(org.eclipse.xtext.serializer.ISerializationContext context,
                                             OrOperator semanticObject)

      Contexts: ComplexEventOperator returns OrOperator BinaryOperator returns OrOperator OrOperator returns OrOperator Constraint: {OrOperator}

    - #### sequence_ParameterizedPatternCall

          protected void sequence_ParameterizedPatternCall(org.eclipse.xtext.serializer.ISerializationContext context,
                                                           ParameterizedPatternCall semanticObject)

      Contexts: ParameterizedPatternCall returns ParameterizedPatternCall Constraint: (eventPattern=[EventPattern|ID] parameterList=PatternCallParameterList?)

    - #### sequence_ParametrizedQueryReference

          protected void sequence_ParametrizedQueryReference(org.eclipse.xtext.serializer.ISerializationContext context,
                                                             ParametrizedQueryReference semanticObject)

      Contexts: ParametrizedQueryReference returns ParametrizedQueryReference Constraint: (query=[Pattern|ID] parameterList=PatternCallParameterList?)

    - #### sequence_PatternCallParameterList

          protected void sequence_PatternCallParameterList(org.eclipse.xtext.serializer.ISerializationContext context,
                                                           PatternCallParameterList semanticObject)

      Contexts: PatternCallParameterList returns PatternCallParameterList Constraint: (parameters+=PatternCallParameter parameters+=PatternCallParameter*)

    - #### sequence_PatternCallParameter

          protected void sequence_PatternCallParameter(org.eclipse.xtext.serializer.ISerializationContext context,
                                                       PatternCallParameter semanticObject)

      Contexts: PatternCallParameter returns PatternCallParameter Constraint: name=ID

    - #### sequence_QueryImport

          protected void sequence_QueryImport(org.eclipse.xtext.serializer.ISerializationContext context,
                                              QueryImport semanticObject)

      Contexts: Import returns QueryImport QueryImport returns QueryImport Constraint: importedNamespace=QualifiedNameWithWildcard

    - #### sequence_QueryResultChangeEventPattern

          protected void sequence_QueryResultChangeEventPattern(org.eclipse.xtext.serializer.ISerializationContext context,
                                                                QueryResultChangeEventPattern semanticObject)

      Contexts: ModelElement returns QueryResultChangeEventPattern EventPattern returns QueryResultChangeEventPattern AbstractAtomicEventPattern returns QueryResultChangeEventPattern QueryResultChangeEventPattern returns QueryResultChangeEventPattern Constraint: (name=ID parameters=TypedParameterList? queryReference=ParametrizedQueryReference resultChangeType=QueryResultChangeType?)

    - #### sequence_Rule

          protected void sequence_Rule(org.eclipse.xtext.serializer.ISerializationContext context,
                                       Rule semanticObject)

      Contexts: ModelElement returns Rule Rule returns Rule Constraint: (name=ID eventPatterns+=ParameterizedPatternCall eventPatterns+=ParameterizedPatternCall* action=XBlockExpression)

    - #### sequence_Timewindow

          protected void sequence_Timewindow(org.eclipse.xtext.serializer.ISerializationContext context,
                                             Timewindow semanticObject)

      Contexts: Timewindow returns Timewindow Constraint: length=INT

    - #### sequence_TraitList

          protected void sequence_TraitList(org.eclipse.xtext.serializer.ISerializationContext context,
                                            TraitList semanticObject)

      Contexts: TraitList returns TraitList Constraint: (traits+=[Trait|ID] traits+=[Trait|ID]*)

    - #### sequence_TraitTypedParameterList

          protected void sequence_TraitTypedParameterList(org.eclipse.xtext.serializer.ISerializationContext context,
                                                          TraitTypedParameterList semanticObject)

      Contexts: TraitTypedParameterList returns TraitTypedParameterList Constraint: (parameters+=TypedParameterWithDefaultValue parameters+=TypedParameterWithDefaultValue*)

    - #### sequence_Trait

          protected void sequence_Trait(org.eclipse.xtext.serializer.ISerializationContext context,
                                        Trait semanticObject)

      Contexts: ModelElement returns Trait Trait returns Trait Constraint: (name=ID parameters=TraitTypedParameterList)

    - #### sequence_TypedParameterList

          protected void sequence_TypedParameterList(org.eclipse.xtext.serializer.ISerializationContext context,
                                                     TypedParameterList semanticObject)

      Contexts: TypedParameterList returns TypedParameterList Constraint: (parameters+=TypedParameter parameters+=TypedParameter*)

    - #### sequence_TypedParameterWithDefaultValue

          protected void sequence_TypedParameterWithDefaultValue(org.eclipse.xtext.serializer.ISerializationContext context,
                                                                 TypedParameterWithDefaultValue semanticObject)

      Contexts: TypedParameterWithDefaultValue returns TypedParameterWithDefaultValue Constraint: (typedParameter=TypedParameter value=XAssignment?)

    - #### sequence_TypedParameter

          protected void sequence_TypedParameter(org.eclipse.xtext.serializer.ISerializationContext context,
                                                 TypedParameter semanticObject)

      Contexts: TypedParameter returns TypedParameter Constraint: (name=ID type=JvmTypeReference)

    - #### sequence_UntilOperator

          protected void sequence_UntilOperator(org.eclipse.xtext.serializer.ISerializationContext context,
                                                UntilOperator semanticObject)

      Contexts: UntilOperator returns UntilOperator Constraint: {UntilOperator}